﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

namespace CreditEventReceiver_Sample
{
    [WebService(Namespace = "http://public.ws.aruba.it/aruba/services/CreditEventReceiver/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class CreditEventReceiver : System.Web.Services.WebService
    {
        public AuthHeader authHeader;

        #region public methods

        [SoapHeader("authHeader", Direction = SoapHeaderDirection.InOut, Required = true)]
        [WebMethod(Description = "Web service operation to receive event that configured credit threshold has been reached.")]
        public WebServiceResult ReceiveThresholdReached(
                string EventGuid
                , DateTime EventDateTime
                , string Username
                , string ExternalUserId
                , int UserId
                , decimal Accountbalance
                , decimal AvailableBalance
                , decimal OverdraftLimit
                , decimal? ThresholdCredit
                , AccountStatusEnum AccountStatus
                , DateTime CreationDate
                , DateTime? RechargeDate
                , DateTime? PlafondDate
                , DateTime? LastTransactionDate
                )
        {
            var result = new WebServiceResult();

            authHeader.Validate();

            try
            {
                // TODO: Add logic here

                result.Success = true;
                result.ResultCode = 0;
            }
            catch (Exception ex)
            {
                result.Success = false;
                result.ResultCode = 1;
                result.ResultMessage = ex.Message;
                result.ExceptionInfo = new ExceptionInfo(ex);
            }
            return result;
        }

        [SoapHeader("authHeader", Direction = SoapHeaderDirection.InOut, Required = true)]
        [WebMethod(Description = "Web service operation to receive event that user credit is exhausted. User credit include plafond amount (if a plafond credit is available for user).")]
        public WebServiceResult ReceiveCreditExhausted(
                string EventGuid
                , DateTime EventDateTime
                , string Username
                , string ExternalUserId
                , int UserId
                , decimal Accountbalance
                , decimal AvailableBalance
                , decimal OverdraftLimit
                , decimal? ThresholdCredit
                , AccountStatusEnum AccountStatus
                , DateTime CreationDate
                , DateTime? RechargeDate
                , DateTime? PlafondDate
                , DateTime? LastTransactionDate
                )
        {
            var result = new WebServiceResult();

            authHeader.Validate();

            try
            {
                // TODO: Add logic here

                result.Success = true;
                result.ResultCode = 0;
            }
            catch (Exception ex)
            {
                result.Success = false;
                result.ResultCode = 1;
                result.ResultMessage = ex.Message;
                result.ExceptionInfo = new ExceptionInfo(ex);
            }

            return result;
        }

        #endregion
    }
}
