﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Web.Services.Protocols;

public class AuthHeader : SoapHeader
{
    public string Username;
    public string Password;

    private string authUserName;
    private string AuthUserName
    {
        get
        {
            if (String.IsNullOrEmpty(authUserName))
                // This is the username required for login
                authUserName = "required username";

            return authUserName;
        }
    }

    private string authPassword;
    private string AuthPassword
    {
        get
        {
            if (String.IsNullOrEmpty(authPassword))
                // This is the password required for login
                authPassword = "required password";

            return authPassword;
        }
    }

    public void Validate()
    {
        if (!(Username == AuthUserName && Password == AuthPassword))
        {
            throw new Exception("Invalid Authentication token");
        }
    }
}
