﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace CreditEventReceiver_Sample
{
    [Serializable]
    public class ExceptionInfo
    {
        protected string _message = string.Empty;
        protected string _source = string.Empty;
        protected string _stackTrace = string.Empty;
        protected string _fullString = string.Empty;

        /// <summary>
        /// Costruttore vuoto. Preferibile non utilizzare.
        /// </summary>
        public ExceptionInfo()
        { }

        public ExceptionInfo(Exception ex)
        {
            this._message = ex.Message;
            this._source = ex.Source;
            this._stackTrace = ex.StackTrace;
            this._fullString = ex.ToString();
            if (ex.InnerException != null)
            {
                this._stackTrace += " " + ex.InnerException.StackTrace;
                this._fullString += " " + ex.InnerException.ToString();
            }
        }

        public string Message
        {
            get { return _message; }
            set { _message = value; }
        }

        public string Source
        {
            get { return _source; }
            set { _source = value; }
        }

        public string StackTrace
        {
            get { return _stackTrace; }
            set { _stackTrace = value; }
        }

        public override string ToString()
        {
            return _fullString;
        }
    }
}